using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace SyncMDIApp
{
    public partial class MainForm : Form
    {
        TabbedMDIManager tabbedMDIManager1 = new TabbedMDIManager();
        static int UniqueNumber = 1;

        public MainForm()
        {
            InitializeComponent();
            tabbedMDIManager1.AttachToMdiContainer(this);
            tabbedMDIManager1.UseIconsInTabs = false;

            dockingManager1.DockStateChanged += new DockStateChangeEventHandler(dockingManager1_DockStateChanged);
        }

        void dockingManager1_DockStateChanged(object sender, DockStateChangeEventArgs arg)
        {
            foreach (Control ctrl in arg.Controls)
            {
                if (ctrl is Form)
                {
                    if (ctrl.Width == 0)
                        this.dockingManager1.SetControlSize(ctrl, new Size(350, ctrl.Height));
                    
                    if (ctrl.Height == 0)
                        this.dockingManager1.SetControlSize(ctrl, new Size(ctrl.Width, 350));
                    //change the position of the form when it is floating
                    if (this.dockingManager1.IsFloating(ctrl) && !(ctrl.Parent is DockingWrapperForm))
                    {
                        DockHost dockHost = ctrl.Parent as Syncfusion.Windows.Forms.Tools.DockHost;
                        FloatingForm floatingFrm = dockHost.ParentForm as FloatingForm;
                        //reduce the size of the form to 50% of main form
                        floatingFrm.Size = new Size((int)(this.Width * 0.5), (int)(this.Height * 0.5));
                        //Locate it int he centre of screen
                        floatingFrm.Location = new Point(this.Size.Width / 2 - floatingFrm.Width / 2, this.Size.Height / 2 - floatingFrm.Height / 2);
                    }
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChildForm form = new ChildForm();
            form.TopLevel = false;
            form.FormBorderStyle = FormBorderStyle.None;
            string name = UniqueName(form.Text);
            form.Name = name;
            form.Text = name;
            Size size = new Size(form.Width, form.Height);
            this.dockingManager1.DockControl(form, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Right, 0);
            this.dockingManager1.SetAsMDIChild(form, true);
            this.dockingManager1.SetControlSize(form, size);
            form.Height = size.Height;
            form.Width = size.Width;
        }

        string UniqueName(string formName)
        {
            string ret = formName + " " + UniqueNumber.ToString();
            UniqueNumber++;
            return ret;
        }
    }
}